'QBasic GFX
'*FOMALHAUT* 1996-2000
'Developed By Agravein

DECLARE SUB prtxt (e%, d%, c%)
DECLARE SUB info ()
DECLARE SUB exiting ()
DECLARE SUB makeprior ()
DECLARE SUB saveall ()
DECLARE SUB putnum (a%)
DECLARE SUB putstring (a$)
DECLARE SUB colour (v%)
DECLARE FUNCTION value% (a%)
DECLARE FUNCTION st$ (a!)
DECLARE SUB menus ()
DECLARE SUB loadall ()
DECLARE FUNCTION getnum! ()
DECLARE FUNCTION getstring$ ()
DECLARE SUB scmove ()
DECLARE SUB Volcano ()
DECLARE SUB rectsnake ()
DECLARE SUB rects ()
DECLARE SUB filline ()
DECLARE FUNCTION timepass! ()
DECLARE SUB timeinit (t%)
DECLARE SUB timewait ()
DECLARE SUB Chaos ()
DECLARE SUB funcpict ()
DECLARE SUB Psi ()
DECLARE SUB palet (c%)
DECLARE SUB flw ()
DECLARE SUB cubedo ()

TYPE menutype
itemname AS STRING * 20
priority AS INTEGER
clsbefore AS INTEGER
clsafter AS INTEGER
paramname AS STRING * 15
leftbound AS INTEGER
increment AS INTEGER
multi AS INTEGER
max AS INTEGER
END TYPE

IF COMMAND$ = "" THEN PRINT "Please run QBGFXrus.bat or QBGFXeng.bat": SYSTEM
DIM SHARED clr(2) AS INTEGER
DIM SHARED cst AS INTEGER
DIM SHARED tim AS DOUBLE
DIM SHARED prevd AS INTEGER
DIM SHARED qua AS INTEGER
DIM SHARED menu(1 TO 20) AS menutype
DIM SHARED delay AS INTEGER
DIM SHARED prior(1000) AS INTEGER
DIM SHARED pq AS INTEGER
DIM SHARED lines(20) AS STRING
DIM SHARED spcont AS INTEGER

loadall

SCREEN 13
info
palet (64)
DO
RANDOMIZE TIMER
d = prior(INT(RND * pq)) - 1
GOSUB rundemo
LOOP

rundemo:
IF menu(d + 1).clsbefore > RND * 20 THEN palet (0): CLS
CALL timeinit(delay * 1): timewait
SELECT CASE d
CASE 0: flw
CASE 1: cubedo
CASE 2: Psi
CASE 3: funcpict
CASE 4: Chaos
CASE 5: filline
CASE 6: rects
CASE 7: rectsnake
CASE 8: Volcano
CASE 9: scmove
END SELECT
IF menu(d + 1).clsafter > RND * 20 THEN palet (0): CLS
prevd = d
RETURN

SUB Chaos
c = 1: a = 0: b = 0
palet (64)

FOR k = 1 TO value(5)
timeinit (18)
DO
a = a + 1: b = b + 1
IF b = 100 THEN b = -b
IF a = 160 THEN a = -a
c = c + 1: IF c = 64 THEN c = -63
LINE (160 - a, 100 - b)-(160 + a, 100 + b), ABS(c) + cst, B, INT(RND * 65536) - 32768
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
LOOP UNTIL timepass = 1
NEXT k
END SUB

SUB colour (v%)
SHARED item, b, a
IF item = v% AND a = b THEN COLOR 15 ELSE COLOR 9
END SUB

SUB cubedo
IF cubed = 1 THEN EXIT SUB
n = value(2)
m = n - 1: q = 16 / (n * 2 - 1)
REDIM w(m, m, m)
FOR a = 0 TO INT(RND * m) + m
x1 = INT(RND * m)
x2 = INT(RND * m)
y1 = INT(RND * m)
y2 = y1
v = INT(RND * 2): IF v = 1 THEN SWAP x1, y1: SWAP x2, y2
DO
w(x1, y1, 0) = 1
IF x1 = x2 AND y1 = y2 THEN EXIT DO
x1 = x1 + SGN(x2 - x1)
y1 = y1 + SGN(y2 - y1)
LOOP
NEXT a

FOR a = 0 TO m
FOR b = 0 TO m
w(a, 0, b) = w(a, b, 0)
w(0, b, a) = w(a, b, 0)
NEXT b, a

palet (64)
v = 10
x1 = 160 - m * v * .3
y1 = 95 - m * v * 1.7
t = (m * 2 + 1) * v / 21.3
FOR Z = 0 TO m * 2
FOR x = 0 TO m * 2
FOR y = m * 2 TO 0 STEP -1
u = w(m - ABS(x - m), m - ABS(y - m), m - ABS(Z - m))
GOSUB cubsub
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
NEXT y, x, Z
EXIT SUB

cubsub: IF u = 0 THEN RETURN
timeinit (1)
x3 = x * v + x1: y3 = y * v + y1: s = (x + y + Z) * v
FOR a = 0 TO v: FOR b = 0 TO v
x2 = a: y2 = b: z2 = v: GOSUB cubsub2
y2 = 0: z2 = b: GOSUB cubsub2
x2 = v: y2 = a: GOSUB cubsub2
NEXT b, a
timewait
RETURN

cubsub2:
z3 = (z2 + Z * v) / SQR(2)
IF z2 = v THEN co = 63 - Z * q ELSE IF y2 = 0 THEN co = 47 - y * q ELSE IF x2 = v THEN co = 31 - x * q
PSET (x2 - z3 + x3, y3 + z3 + y2), co + cst
RETURN

END SUB

SUB exiting
SCREEN 0
WIDTH 80, 25
CLS
SYSTEM
END SUB

SUB filline
palet (0)
v = value(6)
r = (INT(RND * 16) + 1) / 10
x1 = 0 / r: y1 = 0: x2 = 319 / r: y2 = 199: aa = 1: bb = 1
a = x1: b = y1:  PSET (a * r, b), cst
DO
IF aa = 1 THEN a1 = x2 - a ELSE a1 = a - x1
IF bb = 1 THEN b1 = y2 - b ELSE b1 = b - y1
IF a1 > b1 THEN d = b1: GOSUB lin: bb = -bb ELSE d = a1: GOSUB lin: aa = -aa
c = c + 1: IF c = v THEN EXIT DO
IF c MOD 50 = 0 THEN
timewait
timeinit (1)
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
END IF

LOOP
c = 0
EXIT SUB

lin:
a = a + d * aa
b = b + d * bb
LINE -(a * r, b), cst
DRAW "c5u0"
RETURN
END SUB

SUB flw
palet (64)
REDIM q(319) AS INTEGER
d = INT(RND * 3): g = 0: v = 0
DO
DO
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
w = INT(RND * 320)
LOOP UNTIL q(w) >= 0

IF v = 300 THEN CALL timewait: CALL timeinit(1): v = 0
v = v + 1

SELECT CASE d
CASE 0
c = (((w + 160) MOD 128) - 63 + c / 30)
IF ABS(c) > 63 THEN c = -63
CASE 1
c = c + .01: IF c > 63 THEN c = -63
CASE 2
c = (w * q(w) + c / 3) MOD 64
END SELECT

PSET (w, ABS(q(w))), ABS(c) + cst
q(w) = q(w) + 1
IF q(w) = 200 THEN q(w) = -1: g = g + 1: IF g = 320 THEN EXIT DO
LOOP

END SUB

SUB funcpict
palet (128)
ms = (INT(RND * 10) + 1) / 10
d = INT(RND * 17)
FOR x = 0 TO 319
IF x MOD 2 = 0 THEN timewait: timeinit (1)
FOR y = 0 TO 199
aa = ABS(x - 159) * ms + .01
bb = ABS(y - 99) * ms + .01
SELECT CASE d
CASE 0: c = ABS(SIN(COS(aa)) * 100 + COS(SIN(bb)) * 100)
CASE 1: c = ABS(SIN(aa * .523) * bb + COS(bb * .523) * aa)
CASE 2: c = ABS(SIN(aa * 3.14 / 6) * bb)
CASE 3: c = SQR(aa + bb)
CASE 4: c = SQR(aa) * SQR(bb)
CASE 5: c = ABS(aa * aa - bb * bb + aa * bb)
CASE 6: c = ABS(aa * aa - bb * bb)
CASE 7: c = aa * aa + bb * bb + aa * bb
CASE 8: c = SQR(ABS(aa * aa - bb * bb))
CASE 9: c = ABS(SIN(aa / bb) * 8)
CASE 10: c = ABS(bb - 2 * aa)
CASE 11: c = aa / bb
CASE 12: c = aa + 2 * bb
CASE 13: c = ABS(aa - bb)
CASE 14: c = aa + bb - ABS(aa - bb)
CASE 15: c = aa + bb
CASE 16: c = aa * bb
END SELECT
PSET (x, y), ((POINT(x, y) + c) MOD 128) + cst
NEXT y
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
NEXT x
END SUB

FUNCTION getnum
INPUT #1, getnum
END FUNCTION

FUNCTION getstring$
INPUT #1, getstring$
END FUNCTION

SUB info
FOR a = 8 TO 15
CALL prtxt(a * 1, a + 4, a * 4 + 128)
NEXT a
END SUB

SUB loadall

OPEN "qbgfx.cfg" FOR INPUT AS #1
qua = getnum: delay = getnum: spcont = getnum
FOR a = 1 TO qua
menu(a).priority = getnum
menu(a).clsbefore = getnum
menu(a).clsafter = getnum
menu(a).leftbound = getnum
menu(a).increment = getnum - menu(a).leftbound
menu(a).multi = getnum
menu(a).max = getnum
NEXT a
CLOSE #1

OPEN COMMAND$ FOR INPUT AS #1
INPUT #1, a$
INPUT #1, a$
INPUT #1, a$
FOR a = 1 TO qua
menu(a).itemname = getstring$
menu(a).paramname = getstring$
NEXT a
FOR a = 0 TO 20
lines(a) = getstring$
NEXT a
CLOSE #1
makeprior

END SUB

SUB makeprior
pq = 0
FOR a = 1 TO qua
FOR b = 1 TO menu(a).priority
prior(pq) = a
pq = pq + 1
NEXT b
NEXT a
END SUB

SUB menus
SHARED item, b, a
SCREEN 0
WIDTH 80, 25
CLS
COLOR 11
PRINT lines(0)
COLOR 9
b = 1: item = 1
DO
LOCATE 2, 1
FOR a = 1 TO qua
COLOR 9: PRINT menu(a).itemname;
colour (0): PRINT st$(menu(a).priority * 1);
colour (1): PRINT LTRIM$(STR$(menu(a).clsbefore * 5)); "%";
colour (2): PRINT TAB(31); LTRIM$(STR$(menu(a).clsafter * 5)); "%";
COLOR 9: PRINT TAB(36); menu(a).paramname;
colour (3): PRINT st$(menu(a).leftbound * menu(a).multi);
colour (4): PRINT st$((menu(a).leftbound + menu(a).increment) * menu(a).multi)
NEXT a

COLOR 11: PRINT TAB(24); lines(1)
COLOR 12: PRINT lines(2); INT(delay / .18 + .1) / 100; "    "
PRINT MID$(lines(20), 1, LEN(lines(20)) - 7);
PRINT MID$(lines(20), LEN(lines(20)) - 6 + spcont * 3, spcont + 3); " "
COLOR 13
FOR a = 3 TO 11
PRINT lines(a)
NEXT a
DO
i$ = INKEY$
item = (item + (i$ = CHR$(0) + "K") - (i$ = CHR$(0) + "M") + 5) MOD 5
b = (b + (i$ = CHR$(0) + "H") - (i$ = CHR$(0) + "P") + qua - 1) MOD qua + 1
LOOP WHILE i$ = ""
DO: IF (item = 3 OR item = 4) AND menu(b).leftbound = -1 THEN b = (b + 1) MOD qua ELSE EXIT DO
LOOP
IF i$ = " " THEN spcont = 1 - spcont
IF UCASE$(i$) = "S" THEN saveall
IF i$ = CHR$(13) THEN makeprior: SCREEN 13: EXIT SUB
IF i$ = CHR$(27) THEN exiting
c = (i$ = "/") - (i$ = "*")
IF delay + c >= 0 AND delay + c <= 60 THEN delay = delay + c
c = (i$ = "-") - (i$ = "+")
IF c <> 0 THEN
SELECT CASE item
CASE 0
d = menu(b).priority + c
IF d >= 0 AND d < 50 THEN menu(b).priority = d
CASE 1
d = menu(b).clsbefore + c
IF d >= 0 AND d <= 20 THEN menu(b).clsbefore = d
CASE 2
d = menu(b).clsafter + c
IF d >= 0 AND d <= 20 THEN menu(b).clsafter = d
CASE 3
d = menu(b).leftbound + c
e = menu(b).increment - c
IF d >= 0 AND e >= 0 THEN
menu(b).leftbound = d
menu(b).increment = e
END IF
CASE 4
d = menu(b).increment + c
e = menu(b).leftbound + d

IF d >= 0 AND e <= menu(b).max THEN menu(b).increment = d
END SELECT
END IF
LOOP

END SUB

SUB palet (c%)
timeinit (0)
max = 0: cst = 128 - cst
FOR b = 0 TO 2
clr(b) = INT(RND * 63) + 1
IF max < clr(b) THEN max = clr(b)
NEXT b
IF c% = 0 THEN PALETTE cst, clr(0) + clr(1) * 256 + clr(2) * 65536: EXIT SUB
FOR a = 0 TO 63
f = 0
FOR b = 0 TO 2
f = f + INT(a * clr(b) / max) * 256 ^ b
NEXT b
IF a MOD 4 = 0 THEN
timewait
timeinit (1)
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
END IF

PALETTE a + cst, f
IF c% = 128 THEN PALETTE 127 - a + cst, f

NEXT a

END SUB

SUB prtxt (e%, d%, c%)
COLOR c%
LOCATE e%, 21 - INT(LEN(lines(d%)) / 2)
PRINT lines(d%)
END SUB

SUB Psi
palet (128)
a = 0: d = .1: pi = 3.1415
REDIM q(3, 1) AS INTEGER
FOR b = 0 TO 3
g = (b MOD 2) * 2 - 1
gg = INT(b / 2)
q(b, 0) = g * gg
q(b, 1) = g * (1 - gg)
NEXT b

FOR d = 1 TO 190
timeinit (1)
FOR a = 0 TO pi * 2 STEP .5 / d
x = 160 + SIN(a) * d: y = 100 + COS(a) * d
c = 0: v = 0
FOR b = 0 TO 3
p = POINT(x + q(b, 0), y + q(b, 1))
IF p <> 0 THEN v = v + 1: c = c + p MOD 128
NEXT b
IF v > 1 THEN c = c / v
c = INT(c) + INT(RND * 3) + 1
PSET (x, y), c MOD 128 + cst
NEXT a
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
timewait
NEXT d
END SUB

SUB putnum (a%)
SHARED k
IF k = 1 THEN
PRINT #1, LTRIM$(STR$(a%))
ELSE
PRINT #1, LTRIM$(STR$(a%)) + ",";
END IF
END SUB

SUB putstring (a$)
PRINT #1, RTRIM$(a$) + ",";
END SUB

SUB rects
palet (128)
FOR e = 0 TO value(7)
timeinit (5)
DO
x = INT(RND * 320): y = INT(RND * 200)
xa = INT(RND * 3) - 1: ya = INT(RND * 3) - 1
t = INT(RND * 100) + 10
s = INT(RND * 100) + 10
LOOP WHILE xa = 0 AND ya = 0
FOR a = 0 TO s
c = x: d = y
FOR b = 0 TO t
c = c + ya: d = d - xa
c = (c + 320) MOD 320: d = (d + 200) MOD 200
PSET (c, d), ((POINT(c, d) + a) MOD 128) + cst
IF xa * ya <> 0 THEN PSET (c + 1, d), ((POINT(c + 1, d) + a) MOD 128) + cst
NEXT b
x = x + xa: y = y + ya
NEXT a
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
timewait
NEXT e

END SUB

SUB rectsnake

x = 160: y = 100: xs = 0: ys = 0: w = 15: a = 0
palet (64)
RANDOMIZE TIMER
FOR k = 0 TO value(8)
IF k MOD 2 = 1 THEN CALL timewait: CALL timeinit(1)

GOSUB lin2
w = w + 1 + (w >= 63) * 127
x = x + SIN(an)
y = y + COS(an)

GOSUB lin2

xs = xs + (INT(RND * 3)) - 1
ys = ys + (INT(RND * 3)) - 1
an = an + (INT(RND * 3)) * .2 - .2

IF h = 0 THEN
c = INT(RND * 64) / 64
d = INT(RND * 64) / 64
e = INT(RND * 64) / 64
END IF
g = INT(c * h) + INT(d * h) * 256 + INT(e * h) * 65536
PALETTE h + cst, g
h = (h + 1) MOD 64
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
NEXT k
EXIT SUB

lin2:
x = (x + 320) MOD 320: y = (y + 200) MOD 200
a = (x + xs + 320) MOD 320: b = (y + ys + 200) MOD 200
LINE (x, y)-STEP(xs, ys), ABS(w) + cst, B
LINE (a, b)-STEP(-xs, -ys), ABS(w) + cst, B
RETURN

END SUB

SUB saveall
SHARED k
OPEN "qbgfx.cfg" FOR OUTPUT AS #1
k = 0: CALL putnum(qua)
k = 0: CALL putnum(delay)
k = 1: CALL putnum(spcont)
FOR a = 1 TO qua
k = 0: CALL putnum(menu(a).priority)
CALL putnum(menu(a).clsbefore)
CALL putnum(menu(a).clsafter)
CALL putnum(menu(a).leftbound)
CALL putnum(menu(a).increment + menu(a).leftbound)
CALL putnum(menu(a).multi)
k = 1: CALL putnum(menu(a).max)
NEXT a
CLOSE #1
END SUB

SUB scmove
REDIM w(200) AS INTEGER
FOR k = 0 TO value(10)
timeinit (2)
FOR a = 98 TO 0 STEP -1
x = POINT(a, a)
y = POINT(319 - a, 199 - a)
GET (a + 1, a)-(319 - a, a), w
PUT (a, a), w, PSET
GET (a, 199 - a)-(318 - a, 199 - a), w
PUT (a + 1, 199 - a), w, PSET
GET (a, a + 1)-(a, 198 - a), w
PUT (a, a + 2), w, PSET
GET (319 - a, a + 1)-(319 - a, 198 - a), w
PUT (319 - a, a), w, PSET
PSET (a, a + 1), x
PSET (319 - a, 198 - a), y
NEXT a
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
timewait
NEXT k
END SUB

FUNCTION st$ (a!)
IF a! = -1 THEN st$ = "     ": EXIT FUNCTION
a$ = STR$(a!)
st$ = a$ + SPACE$(5 - LEN(a$))
END FUNCTION

SUB timeinit (t%)
DEF SEG = 0
tim = (PEEK(&H46C) + t%) MOD 256
DEF SEG
END SUB

FUNCTION timepass
IF spcont = 1 THEN timepass = 1: EXIT FUNCTION
DEF SEG = 0
b = PEEK(&H46C)
DEF SEG
IF (b > tim AND tim + 100 > b) OR tim - b > 100 OR tim = b THEN timepass = 1 ELSE timepass = 0
END FUNCTION

SUB timewait
IF tim = -1 THEN EXIT SUB
DO
LOOP UNTIL timepass = 1
tim = -1
END SUB

FUNCTION value% (a%)
value% = (menu(a%).leftbound + INT(RND * menu(a%).increment)) * menu(a%).multi
END FUNCTION

SUB Volcano
palet (128)
FOR k = 0 TO value(9)
a = INT(RND * 384) - 32
b = INT(RND * 264) - 32
timeinit (3)
FOR x = -63 TO 63
IF x + a >= 0 AND x + a <= 319 THEN
c = SQR(3969 - x * x)
FOR y = -c TO c
PSET (x + a, y + b), ((POINT(x + a, y + b) + 63 - SQR(x * x + y * y)) MOD 128) + cst
NEXT y
END IF
NEXT x
i$ = INKEY$
IF i$ = " " THEN EXIT SUB
IF i$ = CHR$(27) THEN exiting
IF UCASE$(i$) = "M" THEN menus: EXIT SUB
timewait
NEXT k
END SUB

